// Code generated by counterfeiter. DO NOT EDIT.
package tasklistfakes

import (
	"context"
	"sync"

	"gitlab.com/gaia-x/data-infrastructure-federation-services/tsa/task/internal/service/task"
	"gitlab.com/gaia-x/data-infrastructure-federation-services/tsa/task/internal/service/tasklist"
)

type FakeStorage struct {
	GetGroupTasksStub        func(context.Context, *tasklist.Group) ([]*task.Task, error)
	getGroupTasksMutex       sync.RWMutex
	getGroupTasksArgsForCall []struct {
		arg1 context.Context
		arg2 *tasklist.Group
	}
	getGroupTasksReturns struct {
		result1 []*task.Task
		result2 error
	}
	getGroupTasksReturnsOnCall map[int]struct {
		result1 []*task.Task
		result2 error
	}
	TaskListStub        func(context.Context, string) (*tasklist.TaskList, error)
	taskListMutex       sync.RWMutex
	taskListArgsForCall []struct {
		arg1 context.Context
		arg2 string
	}
	taskListReturns struct {
		result1 *tasklist.TaskList
		result2 error
	}
	taskListReturnsOnCall map[int]struct {
		result1 *tasklist.TaskList
		result2 error
	}
	TaskListHistoryStub        func(context.Context, string) (*tasklist.TaskList, error)
	taskListHistoryMutex       sync.RWMutex
	taskListHistoryArgsForCall []struct {
		arg1 context.Context
		arg2 string
	}
	taskListHistoryReturns struct {
		result1 *tasklist.TaskList
		result2 error
	}
	taskListHistoryReturnsOnCall map[int]struct {
		result1 *tasklist.TaskList
		result2 error
	}
	TaskListTemplateStub        func(context.Context, string) (*tasklist.Template, error)
	taskListTemplateMutex       sync.RWMutex
	taskListTemplateArgsForCall []struct {
		arg1 context.Context
		arg2 string
	}
	taskListTemplateReturns struct {
		result1 *tasklist.Template
		result2 error
	}
	taskListTemplateReturnsOnCall map[int]struct {
		result1 *tasklist.Template
		result2 error
	}
	TaskTemplatesStub        func(context.Context, []string) (map[string]*task.Task, error)
	taskTemplatesMutex       sync.RWMutex
	taskTemplatesArgsForCall []struct {
		arg1 context.Context
		arg2 []string
	}
	taskTemplatesReturns struct {
		result1 map[string]*task.Task
		result2 error
	}
	taskTemplatesReturnsOnCall map[int]struct {
		result1 map[string]*task.Task
		result2 error
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeStorage) GetGroupTasks(arg1 context.Context, arg2 *tasklist.Group) ([]*task.Task, error) {
	fake.getGroupTasksMutex.Lock()
	ret, specificReturn := fake.getGroupTasksReturnsOnCall[len(fake.getGroupTasksArgsForCall)]
	fake.getGroupTasksArgsForCall = append(fake.getGroupTasksArgsForCall, struct {
		arg1 context.Context
		arg2 *tasklist.Group
	}{arg1, arg2})
	stub := fake.GetGroupTasksStub
	fakeReturns := fake.getGroupTasksReturns
	fake.recordInvocation("GetGroupTasks", []interface{}{arg1, arg2})
	fake.getGroupTasksMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeStorage) GetGroupTasksCallCount() int {
	fake.getGroupTasksMutex.RLock()
	defer fake.getGroupTasksMutex.RUnlock()
	return len(fake.getGroupTasksArgsForCall)
}

func (fake *FakeStorage) GetGroupTasksCalls(stub func(context.Context, *tasklist.Group) ([]*task.Task, error)) {
	fake.getGroupTasksMutex.Lock()
	defer fake.getGroupTasksMutex.Unlock()
	fake.GetGroupTasksStub = stub
}

func (fake *FakeStorage) GetGroupTasksArgsForCall(i int) (context.Context, *tasklist.Group) {
	fake.getGroupTasksMutex.RLock()
	defer fake.getGroupTasksMutex.RUnlock()
	argsForCall := fake.getGroupTasksArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeStorage) GetGroupTasksReturns(result1 []*task.Task, result2 error) {
	fake.getGroupTasksMutex.Lock()
	defer fake.getGroupTasksMutex.Unlock()
	fake.GetGroupTasksStub = nil
	fake.getGroupTasksReturns = struct {
		result1 []*task.Task
		result2 error
	}{result1, result2}
}

func (fake *FakeStorage) GetGroupTasksReturnsOnCall(i int, result1 []*task.Task, result2 error) {
	fake.getGroupTasksMutex.Lock()
	defer fake.getGroupTasksMutex.Unlock()
	fake.GetGroupTasksStub = nil
	if fake.getGroupTasksReturnsOnCall == nil {
		fake.getGroupTasksReturnsOnCall = make(map[int]struct {
			result1 []*task.Task
			result2 error
		})
	}
	fake.getGroupTasksReturnsOnCall[i] = struct {
		result1 []*task.Task
		result2 error
	}{result1, result2}
}

func (fake *FakeStorage) TaskList(arg1 context.Context, arg2 string) (*tasklist.TaskList, error) {
	fake.taskListMutex.Lock()
	ret, specificReturn := fake.taskListReturnsOnCall[len(fake.taskListArgsForCall)]
	fake.taskListArgsForCall = append(fake.taskListArgsForCall, struct {
		arg1 context.Context
		arg2 string
	}{arg1, arg2})
	stub := fake.TaskListStub
	fakeReturns := fake.taskListReturns
	fake.recordInvocation("TaskList", []interface{}{arg1, arg2})
	fake.taskListMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeStorage) TaskListCallCount() int {
	fake.taskListMutex.RLock()
	defer fake.taskListMutex.RUnlock()
	return len(fake.taskListArgsForCall)
}

func (fake *FakeStorage) TaskListCalls(stub func(context.Context, string) (*tasklist.TaskList, error)) {
	fake.taskListMutex.Lock()
	defer fake.taskListMutex.Unlock()
	fake.TaskListStub = stub
}

func (fake *FakeStorage) TaskListArgsForCall(i int) (context.Context, string) {
	fake.taskListMutex.RLock()
	defer fake.taskListMutex.RUnlock()
	argsForCall := fake.taskListArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeStorage) TaskListReturns(result1 *tasklist.TaskList, result2 error) {
	fake.taskListMutex.Lock()
	defer fake.taskListMutex.Unlock()
	fake.TaskListStub = nil
	fake.taskListReturns = struct {
		result1 *tasklist.TaskList
		result2 error
	}{result1, result2}
}

func (fake *FakeStorage) TaskListReturnsOnCall(i int, result1 *tasklist.TaskList, result2 error) {
	fake.taskListMutex.Lock()
	defer fake.taskListMutex.Unlock()
	fake.TaskListStub = nil
	if fake.taskListReturnsOnCall == nil {
		fake.taskListReturnsOnCall = make(map[int]struct {
			result1 *tasklist.TaskList
			result2 error
		})
	}
	fake.taskListReturnsOnCall[i] = struct {
		result1 *tasklist.TaskList
		result2 error
	}{result1, result2}
}

func (fake *FakeStorage) TaskListHistory(arg1 context.Context, arg2 string) (*tasklist.TaskList, error) {
	fake.taskListHistoryMutex.Lock()
	ret, specificReturn := fake.taskListHistoryReturnsOnCall[len(fake.taskListHistoryArgsForCall)]
	fake.taskListHistoryArgsForCall = append(fake.taskListHistoryArgsForCall, struct {
		arg1 context.Context
		arg2 string
	}{arg1, arg2})
	stub := fake.TaskListHistoryStub
	fakeReturns := fake.taskListHistoryReturns
	fake.recordInvocation("TaskListHistory", []interface{}{arg1, arg2})
	fake.taskListHistoryMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeStorage) TaskListHistoryCallCount() int {
	fake.taskListHistoryMutex.RLock()
	defer fake.taskListHistoryMutex.RUnlock()
	return len(fake.taskListHistoryArgsForCall)
}

func (fake *FakeStorage) TaskListHistoryCalls(stub func(context.Context, string) (*tasklist.TaskList, error)) {
	fake.taskListHistoryMutex.Lock()
	defer fake.taskListHistoryMutex.Unlock()
	fake.TaskListHistoryStub = stub
}

func (fake *FakeStorage) TaskListHistoryArgsForCall(i int) (context.Context, string) {
	fake.taskListHistoryMutex.RLock()
	defer fake.taskListHistoryMutex.RUnlock()
	argsForCall := fake.taskListHistoryArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeStorage) TaskListHistoryReturns(result1 *tasklist.TaskList, result2 error) {
	fake.taskListHistoryMutex.Lock()
	defer fake.taskListHistoryMutex.Unlock()
	fake.TaskListHistoryStub = nil
	fake.taskListHistoryReturns = struct {
		result1 *tasklist.TaskList
		result2 error
	}{result1, result2}
}

func (fake *FakeStorage) TaskListHistoryReturnsOnCall(i int, result1 *tasklist.TaskList, result2 error) {
	fake.taskListHistoryMutex.Lock()
	defer fake.taskListHistoryMutex.Unlock()
	fake.TaskListHistoryStub = nil
	if fake.taskListHistoryReturnsOnCall == nil {
		fake.taskListHistoryReturnsOnCall = make(map[int]struct {
			result1 *tasklist.TaskList
			result2 error
		})
	}
	fake.taskListHistoryReturnsOnCall[i] = struct {
		result1 *tasklist.TaskList
		result2 error
	}{result1, result2}
}

func (fake *FakeStorage) TaskListTemplate(arg1 context.Context, arg2 string) (*tasklist.Template, error) {
	fake.taskListTemplateMutex.Lock()
	ret, specificReturn := fake.taskListTemplateReturnsOnCall[len(fake.taskListTemplateArgsForCall)]
	fake.taskListTemplateArgsForCall = append(fake.taskListTemplateArgsForCall, struct {
		arg1 context.Context
		arg2 string
	}{arg1, arg2})
	stub := fake.TaskListTemplateStub
	fakeReturns := fake.taskListTemplateReturns
	fake.recordInvocation("TaskListTemplate", []interface{}{arg1, arg2})
	fake.taskListTemplateMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeStorage) TaskListTemplateCallCount() int {
	fake.taskListTemplateMutex.RLock()
	defer fake.taskListTemplateMutex.RUnlock()
	return len(fake.taskListTemplateArgsForCall)
}

func (fake *FakeStorage) TaskListTemplateCalls(stub func(context.Context, string) (*tasklist.Template, error)) {
	fake.taskListTemplateMutex.Lock()
	defer fake.taskListTemplateMutex.Unlock()
	fake.TaskListTemplateStub = stub
}

func (fake *FakeStorage) TaskListTemplateArgsForCall(i int) (context.Context, string) {
	fake.taskListTemplateMutex.RLock()
	defer fake.taskListTemplateMutex.RUnlock()
	argsForCall := fake.taskListTemplateArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeStorage) TaskListTemplateReturns(result1 *tasklist.Template, result2 error) {
	fake.taskListTemplateMutex.Lock()
	defer fake.taskListTemplateMutex.Unlock()
	fake.TaskListTemplateStub = nil
	fake.taskListTemplateReturns = struct {
		result1 *tasklist.Template
		result2 error
	}{result1, result2}
}

func (fake *FakeStorage) TaskListTemplateReturnsOnCall(i int, result1 *tasklist.Template, result2 error) {
	fake.taskListTemplateMutex.Lock()
	defer fake.taskListTemplateMutex.Unlock()
	fake.TaskListTemplateStub = nil
	if fake.taskListTemplateReturnsOnCall == nil {
		fake.taskListTemplateReturnsOnCall = make(map[int]struct {
			result1 *tasklist.Template
			result2 error
		})
	}
	fake.taskListTemplateReturnsOnCall[i] = struct {
		result1 *tasklist.Template
		result2 error
	}{result1, result2}
}

func (fake *FakeStorage) TaskTemplates(arg1 context.Context, arg2 []string) (map[string]*task.Task, error) {
	var arg2Copy []string
	if arg2 != nil {
		arg2Copy = make([]string, len(arg2))
		copy(arg2Copy, arg2)
	}
	fake.taskTemplatesMutex.Lock()
	ret, specificReturn := fake.taskTemplatesReturnsOnCall[len(fake.taskTemplatesArgsForCall)]
	fake.taskTemplatesArgsForCall = append(fake.taskTemplatesArgsForCall, struct {
		arg1 context.Context
		arg2 []string
	}{arg1, arg2Copy})
	stub := fake.TaskTemplatesStub
	fakeReturns := fake.taskTemplatesReturns
	fake.recordInvocation("TaskTemplates", []interface{}{arg1, arg2Copy})
	fake.taskTemplatesMutex.Unlock()
	if stub != nil {
		return stub(arg1, arg2)
	}
	if specificReturn {
		return ret.result1, ret.result2
	}
	return fakeReturns.result1, fakeReturns.result2
}

func (fake *FakeStorage) TaskTemplatesCallCount() int {
	fake.taskTemplatesMutex.RLock()
	defer fake.taskTemplatesMutex.RUnlock()
	return len(fake.taskTemplatesArgsForCall)
}

func (fake *FakeStorage) TaskTemplatesCalls(stub func(context.Context, []string) (map[string]*task.Task, error)) {
	fake.taskTemplatesMutex.Lock()
	defer fake.taskTemplatesMutex.Unlock()
	fake.TaskTemplatesStub = stub
}

func (fake *FakeStorage) TaskTemplatesArgsForCall(i int) (context.Context, []string) {
	fake.taskTemplatesMutex.RLock()
	defer fake.taskTemplatesMutex.RUnlock()
	argsForCall := fake.taskTemplatesArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeStorage) TaskTemplatesReturns(result1 map[string]*task.Task, result2 error) {
	fake.taskTemplatesMutex.Lock()
	defer fake.taskTemplatesMutex.Unlock()
	fake.TaskTemplatesStub = nil
	fake.taskTemplatesReturns = struct {
		result1 map[string]*task.Task
		result2 error
	}{result1, result2}
}

func (fake *FakeStorage) TaskTemplatesReturnsOnCall(i int, result1 map[string]*task.Task, result2 error) {
	fake.taskTemplatesMutex.Lock()
	defer fake.taskTemplatesMutex.Unlock()
	fake.TaskTemplatesStub = nil
	if fake.taskTemplatesReturnsOnCall == nil {
		fake.taskTemplatesReturnsOnCall = make(map[int]struct {
			result1 map[string]*task.Task
			result2 error
		})
	}
	fake.taskTemplatesReturnsOnCall[i] = struct {
		result1 map[string]*task.Task
		result2 error
	}{result1, result2}
}

func (fake *FakeStorage) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.getGroupTasksMutex.RLock()
	defer fake.getGroupTasksMutex.RUnlock()
	fake.taskListMutex.RLock()
	defer fake.taskListMutex.RUnlock()
	fake.taskListHistoryMutex.RLock()
	defer fake.taskListHistoryMutex.RUnlock()
	fake.taskListTemplateMutex.RLock()
	defer fake.taskListTemplateMutex.RUnlock()
	fake.taskTemplatesMutex.RLock()
	defer fake.taskTemplatesMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakeStorage) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ tasklist.Storage = new(FakeStorage)
